/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2003 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */

package org.objectweb.medor.filter.api;

/**
 *
 * @author Sebastien Chassande-Barrioz
 */
public interface Operator extends Expression {

    public final static String LOWER = "<";
    public final static String GREATER = ">";
    public final static String LOWEREQUAL = "<=";
    public final static String GREATEREQUAL = ">=";
    public final static String NOT = "!";
	public final static String CONDAND = "&&";
	public final static String CONCAT = "concat";
    public final static String AND = "&";
    public final static String CONDOR = "||";
    public final static String OR = "|";
    public final static String EQUAL = "==";
    public final static String NOTEQUAL = "!=";
    public final static String PLUS = "+";
    public final static String MINUS = "-";
    public final static String UMINUS = "-";
    public final static String MULT = "*";
    public final static String DIV = "/";
    public final static String BITWIZE = "~";
    public final static String NAV = ".";
    public final static String IN = "IN";
    public final static String LENGTH = "length";
    public final static String FIRSTLOCATE = "position";
    public final static String INDEXEDLOCATE = "locate";
    public final static String SQRT = "sqrt";
    public final static String ABS = "abs";
    public final static String SUBSTRING = "substring";
	public final static String MEMBEROF = "memberof";
	public final static String NOTMEMBEROF = "notmemberof";


    /**
     * Returns the String representing the operator in Java
     * @return the String representing the operator in Java
     */
    String getOperatorString();

    int getOperandNumber();

    Expression getExpression(int idx) throws ArrayIndexOutOfBoundsException;

    void setExpression(int idx, Expression exp)
		throws ArrayIndexOutOfBoundsException;
}
