/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2003 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */
package org.objectweb.medor.filter.api;

public interface ThreeArgsOperator extends Operator {

    /**
     * This method sets the first operand or operator to this expression object.
     * There is no verification of types when performing this method.
     * After evaluating, we must compile this expression.
     */
    public void setFirstExpression(Expression firstChild)
            throws IllegalStateException;

    /**
     * This method sets the second operand or operator to this expression object.
     * There is no verification of types when performing this method.
     * After evaluating, we must compile this expression.
     */
    public void setSecondExpression(Expression secondChild)
            throws IllegalStateException;

    /**
     * This method sets the third operand or operator to this expression object.
     * There is no verification of types when performing this method.
     * After evaluating, we must compile this expression.
     */
    public void setThirdExpression(Expression thirdChild)
            throws IllegalStateException;

    public Expression getFirstExpression();

    public Expression getSecondExpression();

    public Expression getThirdExpression();
}
