/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2003 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */
package org.objectweb.medor.filter.lib;

import org.objectweb.medor.filter.api.Expression;
import org.objectweb.medor.filter.api.Operator;
import org.objectweb.medor.api.TypingException;

public class Bitwize extends BasicUnaryArithmeticOperator {

    public Bitwize() {
    }

    public Bitwize(Expression e) {
        this.operand = e;
    }

    public int evaluate(int op) {
        return (-op)-1;
    }

    public int evaluate(short op) throws TypingException{
        throw new TypingException("~(short)");
    }

    public long evaluate(long op) throws TypingException{
        throw new TypingException("~(long)");
    }

    public float evaluate(float op) throws TypingException{
        throw new TypingException("~(float)");
    }

    public int evaluate(byte op) throws TypingException{
        throw new TypingException("~(byte)");
    }

    public double evaluate(double op) throws TypingException{
        throw new TypingException("~(double)");
    }

    public String getOperatorString() {
        return Operator.BITWIZE;
    }
}
