/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2003 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */

package org.objectweb.medor.filter.lib;

import org.objectweb.medor.api.TypingException;
import org.objectweb.medor.filter.api.Expression;
import org.objectweb.medor.filter.api.Operator;

import java.util.Date;
import java.sql.Time;
import java.sql.Timestamp;

/**
 *
 * @author Sebastien Chassande-Barrioz
 */
public class Minus extends BasicBinaryArithmeticOperator {

    public Minus() {
    }

    public Minus(Expression l, Expression r) {
        this.left = l;
        this.right = r;
    }

    public int evaluate(int op1, int op2) {
        int result = op1 - op2;
        return result;
    }

    public int evaluate(int op1, short op2) {
        int result = op1 - op2;
        return result;
    }

    public long evaluate(int op1, long op2) {
        long result = op1 - op2;
        return result;
    }

    public float evaluate(int op1, float op2) {
        float result = op1 - op2;
        return result;
    }

    public double evaluate(int op1, double op2) {
        double result = op1 - op2;
        return result;
    }

    public float evaluate(float op1, float op2) {
        float result = op1 - op2;
        return result;
    }

    public float evaluate(float op1, short op2) {
        float result = op1 - op2;
        return result;
    }

    public float evaluate(float op1, int op2) {
        float result = op1 - op2;
        return result;
    }

    public float evaluate(float op1, long op2) {
        float result = op1 - op2;
        return result;
    }

    public double evaluate(float op1, double op2) {
        double result = op1 - op2;
        return result;
    }

    public int evaluate(char op1, char op2) {
        int result = op1 - op2;
        return result;
    }

    public long evaluate(long op1, long op2) {
        long result = op1 - op2;
        return result;
    }

    public long evaluate(long op1, short op2) {
        long result = op1 - op2;
        return result;
    }

    public long evaluate(long op1, int op2) {
        long result = op1 - op2;
        return result;
    }

    public float evaluate(long op1, float op2) {
        float result = op1 - op2;
        return result;
    }

    public double evaluate(long op1, double op2) {
        double result = op1 - op2;
        return result;
    }

    public double evaluate(double op1, double op2) {
        double result = op1 - op2;
        return result;
    }

    public double evaluate(double op1, short op2) {
        double result = op1 - op2;
        return result;
    }

    public double evaluate(double op1, int op2) {
        double result = op1 - op2;
        return result;
    }

    public double evaluate(double op1, float op2) {
        double result = op1 - op2;
        return result;
    }

    public double evaluate(double op1, long op2) {
        double result = op1 - op2;
        return result;
    }

    public String evaluate(char op1, String op2) throws TypingException {
        throw new TypingException("Minus(String, String)");
    }

    public String evaluate(String op1, String op2) throws TypingException {
        throw new TypingException("Minus(String, String)");
    }

    public Time evaluate(Time op1, Time op2) throws TypingException {
        throw new TypingException("Minus(Time, Time)");
    }

    public Timestamp evaluate(Timestamp op1, Timestamp op2)
		throws TypingException {
        throw new TypingException("Minus(Timestamp, Timestamp)");
    }

    public Date evaluate(Date op1, Date op2) throws TypingException {
        throw new TypingException("Minus(Date, Date)");
    }

    public String evaluate(String op1, char op2) throws TypingException {
        throw new TypingException("Minus(String, char)");
    }

	public String getOperatorString() {
		return Operator.MINUS;
	}

}
