/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2003 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */
package org.objectweb.medor.query.api;

import org.objectweb.jorm.type.api.PType;
import org.objectweb.medor.api.Field;
import org.objectweb.medor.api.MedorException;
import org.objectweb.medor.filter.api.Expression;
import org.objectweb.medor.tuple.api.TupleCollection;
import org.objectweb.medor.tuple.api.TupleLoader;

/**
 * It's a DataStore witch is attached to a Medor TupleCollection Data Store...
 */
public interface TCQueryLeaf extends QueryLeaf {

    public TupleCollection getTupleCollection();

    public TupleLoader getTupleLoader();

    public void setTupleLoader(TupleLoader tl);

    public QueryTreeField addField(String fieldName, PType type, Field tcField)
            throws MedorException;

    public Expression getQueryFilter();

    public void setQueryFilter(Expression filter);
}
