/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2003 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */

package org.objectweb.medor.query.lib;

import org.objectweb.medor.filter.api.Expression;
import org.objectweb.medor.query.api.OperationType;
import org.objectweb.medor.query.api.OptimizationMetaData;

/**
 *
 * @author Sebastien Chassande-Barrioz
 */
public class JoinProject extends BasicQueryNode {

	/**
	 * Basic constructor. Fields and filter must be added later.
	 */
    public JoinProject(String name, OptimizationMetaData optimizationMD) {
        super(name, optimizationMD);
    }

	/**
	 * Basic constructor. Fields must be added later.
	 */
    public JoinProject(Expression filter,
                       String name,
                       OptimizationMetaData optimizationMD
                       ) {
        super(name, optimizationMD);
        this.setQueryFilter(filter);
    }

    public short getType() {
        return OperationType.JOIN_PROJECT;
    }
}
