/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2003 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */

/**
 * Package definition.
 */
package org.objectweb.medor.query.lib;

import org.objectweb.medor.api.MedorException;
import org.objectweb.medor.api.TupleStructure;
import org.objectweb.medor.query.api.OperationType;
import org.objectweb.medor.query.api.OptimizationMetaData;
import org.objectweb.medor.query.api.QueryTree;
import org.objectweb.medor.query.api.QueryTreeField;
import org.objectweb.medor.filter.api.Expression;

public class Union extends BasicQueryNode {

    public Union(QueryTree leftQT,
                 QueryTree rightQT,
                 String nodeName,
                 OptimizationMetaData optimizationMD)
            throws MedorException {
        super(nodeName, optimizationMD);

        //test if the two QueryTree have the same TupleStructure
        if (leftQT.getTupleStructure().getSize()
                != rightQT.getTupleStructure().getSize()) {
            throw new MedorException(
                    "Impossible to perform Union Operation");
        }
        for (int i = 1; i < leftQT.getTupleStructure().getSize(); i++) {
            if (!leftQT.getTupleStructure().getField(i).getName()
                    .equalsIgnoreCase(
                            rightQT.getTupleStructure().getField(i).getName())) {
                throw new MedorException(
                        "Impossible to perform Union Operation");
            }
        }
		//add all Fields of the underlying QueryTrees
		for (int i = 1; i < leftQT.getTupleStructure().getSize(); i++) {
			QueryTreeField[] anc = new QueryTreeField[2];

		}
	}

    public short getType() {
        return OperationType.UNION;
    }

    public void setQueryFilter(Expression e) {
        throw new UnsupportedOperationException("Unions cannot be assigned a filter.");
	}

}
