/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2003 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */

package org.objectweb.medor.tuple.lib;

import org.objectweb.medor.api.MedorException;
import org.objectweb.medor.api.TupleStructure;
import org.objectweb.medor.tuple.api.TupleCollection;

import javax.swing.*;
import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.LinkedList;

public class TupleCollectionView extends JFrame {
    public TupleCollectionView(TupleCollection tc) throws MedorException {
        org.objectweb.medor.tuple.api.Tuple t;
        Object o;
        int nbTuple;
        Object[][] data;
        int nbAtt = tc.getMetaData().getSize();
        LinkedList tuples = new LinkedList();
        int c;
        int l;
        tc.first();
        if (tc.isEmpty())
            throw new MedorException("The TupleCollection is empty");
        else {
            do {
                //Tuple t1 = tc.getTuple();
                //MemoryTuple t2 = (MemoryTuple)t1;
                o = tc.getTuple();//.clone();
                tuples.add(o);
            } while (tc.next());
            nbTuple = tuples.size();
            data = new Object[nbTuple][nbAtt];
            for (l = 0; (l < nbTuple); l++) {
                t = (org.objectweb.medor.tuple.api.Tuple) tuples.get(l);
                for (c = 1; (c <= nbAtt); c++) data[l][c - 1] = t.getObject(c);
            }

            TupleStructure md1 = tc.getMetaData();
            String[] columnNames = new String[nbAtt];
            c = 0;
            while (c <= (nbAtt - 1)) {
                columnNames[c] = md1.getField(c + 1).getName();
                c++;
            }

            final JTable table = new JTable(data, columnNames);
            table.setPreferredScrollableViewportSize(new Dimension(1000, 150));

            //Create the scroll pane and add the table to it.
            JScrollPane scrollPane = new JScrollPane(table);

            //Add the scroll pane to this window.
            getContentPane().add(scrollPane, BorderLayout.CENTER);

            addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            });
        }
    }
}
