/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 *
 * Copyright (C) 2001-2003 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, A. Lefebvre
 */
package org.objectweb.medor.type.lib;

import org.objectweb.jorm.type.api.PType;
import org.objectweb.jorm.type.api.PTypeSpace;

/**
 * @author S.Chassande-Barrioz
 */
public class QType extends PType {

    public final static short TYPECODE_NAMING_CONTEXT = 200;
    public final static short TYPECODE_TUPLE_COLLECTION = 201;
	public final static short TYPECODE_PNAME = 202;
	public final static short TYPECODE_OBJECT = 203;
	public final static short TYPECODE_COLLECTION = 204;


    public QType(short typecode, String jormname, String javaname,
				 String constname) {
        super(typecode, jormname, javaname, constname, null);
    }

    public QType(String classname, PTypeSpace typespace) {
        super(classname, typespace);
    }

	public boolean isa(PType type) {
		return (type.getTypeCode() == QType.TYPECODE_NAMING_CONTEXT
			? getTypeCode() == QType.TYPECODE_NAMING_CONTEXT
			: super.isa(type));
	}
}
